package it.sw.pa.comune.artegna.repository;

import it.sw.pa.comune.artegna.domain.Prenotazione;
import it.sw.pa.comune.artegna.domain.enumeration.StatoPrenotazione;
import java.util.Collection;
import java.util.List;
import java.util.Optional;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.*;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

/**
 * Spring Data JPA repository for the Prenotazione entity.
 */
@Repository
public interface PrenotazioneRepository extends JpaRepository<Prenotazione, Long>, JpaSpecificationExecutor<Prenotazione> {
    default Optional<Prenotazione> findOneWithEagerRelationships(Long id) {
        return this.findOneWithToOneRelationships(id);
    }

    default List<Prenotazione> findAllWithEagerRelationships() {
        return this.findAllWithToOneRelationships();
    }

    default Page<Prenotazione> findAllWithEagerRelationships(Pageable pageable) {
        return this.findAllWithToOneRelationships(pageable);
    }

    @Query(
        value = "select prenotazione from Prenotazione prenotazione left join fetch prenotazione.utente left join fetch prenotazione.struttura",
        countQuery = "select count(prenotazione) from Prenotazione prenotazione"
    )
    Page<Prenotazione> findAllWithToOneRelationships(Pageable pageable);

    @Query("select prenotazione from Prenotazione prenotazione left join fetch prenotazione.utente left join fetch prenotazione.struttura")
    List<Prenotazione> findAllWithToOneRelationships();

    @Query(
        "select prenotazione from Prenotazione prenotazione left join fetch prenotazione.utente left join fetch prenotazione.struttura where prenotazione.id =:id"
    )
    Optional<Prenotazione> findOneWithToOneRelationships(@Param("id") Long id);

    Long id(Long id);
}
